﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinEditors
Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    Private dropDownInProgress As Boolean = False

    Private Sub UltraGrid1_InitializeLayout(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        With e.Layout
            With .Bands(0)
                .Columns(1).EditorComponent = Me.UltraTextEditor1
            End With
        End With
    End Sub

    Private Sub UltraTextEditor1_BeforeEditorButtonDropDown(sender As Object, e As BeforeEditorButtonDropDownEventArgs) Handles UltraTextEditor1.BeforeEditorButtonDropDown

        If dropDownInProgress Then Return

        Dim grid As UltraGrid = Me.UltraGrid1
        Dim activeCell As UltraGridCell = grid.ActiveCell
        If activeCell Is Nothing Then Return

        If grid.ActiveCell.Column.Key = "Column 1" Then
            e.Cancel = True
            grid.BeginInvoke(New MethodInvoker(AddressOf Me.DropDownButton))
        End If
    End Sub

    Private Sub DropDownButton()

        Dim grid = Me.UltraGrid1
        Dim activeCell As UltraGridCell = grid.ActiveCell
        If activeCell Is Nothing Then Return

        Dim editor As EditorWithText = activeCell.EditorResolved
        If editor Is Nothing Then Return

        Dim dropdownButton As DropDownEditorButton = editor.ButtonsRight(0)
        If dropdownButton Is Nothing Then Return

        dropDownInProgress = True
        Try

            dropdownButton.DropDown()

            For Each form As Form In Me.OwnedForms
                If form.GetType().Name = "DropDownForm" Then
                    Dim editorElement As EmbeddableUIElementBase = activeCell.EditorResolved.ElementBeingEdited
                    Dim clientRect As Rectangle = editorElement.Rect
                    Dim screenRect As Rectangle = grid.RectangleToScreen(clientRect)
                    Dim location As Point = New Point(screenRect.Left, screenRect.Top)
                    form.Location = location
                    Exit For
                End If
            Next
        Finally
            dropDownInProgress = False
        End Try
    End Sub


End Class
